Package org.eclipse.birt.chart.computation

# Class Engine3D

java.lang.Object
org.eclipse.birt.chart.computation.Engine3D

All Implemented Interfaces:
  `IConstants`

public final class Engine3D extends Object implements IConstants
Engine3D

## Field Summary

Fields
Modifier and Type
Field
Description
`static final byte`
`OUT_OF_RANGE_BOTH`
Indicates the both points are out of range in clipping.
`static final byte`
`OUT_OF_RANGE_END`
Indicates the ending point is out of range in clipping.
`static final byte`
`OUT_OF_RANGE_NONE`
Indicates the both points are in range in clipping.
`static final byte`
`OUT_OF_RANGE_START`
Indicates the starting point is out of range in clipping.

### Fields inherited from interface org.eclipse.birt.chart.computation.IConstants

`ABOVE, ANCILLARY_AXIS, ANCILLARY_BASE, ARRAY, AUTO, AVERAGE, AXIS, BACKWARD, BASE, BASE_AXIS, BELOW, BIG_NUMBER_PRIMITIVE_ARRAY, BOOLEAN, BOTTOM, CENTER, COLLECTION, DATE_TIME, DESIGN_TIME, EMPTY_STRING, EQUAL, FORWARD, HORIZONTAL, INSIDE, LABELS, LEFT, LEGEND_ENTRY, LEGEND_GROUP_NAME, LEGEND_MINSLICE_ENTRY, LEGEND_SEPERATOR, LESS, LINE_EXPAND_DOUBLE_SIZE, LINE_EXPAND_SIZE, LINEAR, LOG_10, LOGARITHMIC, MAJOR, MAX, MIN, MINOR, MORE, NON_PRIMITIVE_ARRAY, NULL_STRING, NUMBER_PRIMITIVE_ARRAY, NUMERICAL, ONE_SPACE, ORTHOGONAL, ORTHOGONAL_AXIS, OTHER, OUTSIDE, PERCENT, POSITION_MASK, POSITION_MOVE_ABOVE, POSITION_MOVE_BELOW, POSITION_MOVE_LEFT, POSITION_MOVE_RIGHT, PRIMITIVE_ARRAY, RIGHT, RUN_TIME, SOME_NULL, TEXT, THREE_D, TICK_ABOVE, TICK_ACROSS, TICK_BELOW, TICK_LEFT, TICK_NONE, TICK_RIGHT, TICK_SIDE1, TICK_SIDE2, TICK_SIZE, TOP, TWO_5_D, TWO_D, UNDEFINED, UNDEFINED_STRING, USER_INTERFACE, VALUE, VERTICAL`

## Constructor Summary

Constructors
Constructor
Description
`Engine3D(Rotation3D rotation, Vector lightDirection, double viewerWidth, double viewerHeight)`
`Engine3D(Rotation3D rotation, Vector lightDirection, double viewerWidth, double viewerHeight, double viewingDistance, double modelingDistance, double hitherDistance, double yonDistance, double perspectiveDistance)`

## Method Summary

Modifier and Type
Method
Description
`byte`
`checkClipping(Vector start, Vector end)`
Clipping the lines according to viewing volumn.
`static Object3D`
`getObjectFromEvent(Object event)`
`static Object3D`
`getObjectFromEvent(Object event, boolean bParent)`
`static Object3D`
`getParentObject(Object event)`
`WrappedInstruction`
`getSharedEdge(I3DRenderEvent event1, I3DRenderEvent event2, double xOffset, double yOffset)`
`Vector`
`getViewReferencePoint()`
`List`
`processEvent(List renderingEvents, double xOffset, double yOffset)`
Transforms 3D polygons and sort their rendering order, and antialias.
`List`
`processEvent(List renderingEvents, double xOffset, double yOffset, boolean antialiasing)`
Transforms 3D polygons and sort their rendering order, and antialias.
`PrimitiveRenderEvent`
`processEvent(PrimitiveRenderEvent event, double xOffset, double yOffset)`
`PrimitiveRenderEvent`
`processEvent_noclip(PrimitiveRenderEvent event, double xOffset, double yOffset)`
`void`
`reset()`
Resets the engine to default state.
`void`
`translate(Vector v)`
Translates the view frame.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### OUT_OF_RANGE_NONE

public static final byte OUT_OF_RANGE_NONE
Indicates the both points are in range in clipping.

See Also:
  - Constant Field Values

### OUT_OF_RANGE_END

public static final byte OUT_OF_RANGE_END
Indicates the ending point is out of range in clipping.

See Also:
  - Constant Field Values

### OUT_OF_RANGE_START

public static final byte OUT_OF_RANGE_START
Indicates the starting point is out of range in clipping.

See Also:
  - Constant Field Values

### OUT_OF_RANGE_BOTH

public static final byte OUT_OF_RANGE_BOTH
Indicates the both points are out of range in clipping.

See Also:
  - Constant Field Values

## Constructor Details

### Engine3D

public Engine3D(Rotation3D rotation, Vector lightDirection, double viewerWidth, double viewerHeight, double viewingDistance, double modelingDistance, double hitherDistance, double yonDistance, double perspectiveDistance)

Parameters:
  `rotation` -
  `lightDirection` -
  `viewerWidth` -
  `viewerHeight` -
  `viewingDistance` -
  `hitherDistance` -
  `yonDistance` -

### Engine3D

public Engine3D(Rotation3D rotation, Vector lightDirection, double viewerWidth, double viewerHeight)

Parameters:
  `rotation` -
  `lightDirection` -
  `viewerWidth` -
  `viewerHeight` -

## Method Details

### reset

public void reset()
Resets the engine to default state.

### translate

public void translate(Vector v)
Translates the view frame.

Parameters:
  `v` -

### checkClipping

public byte checkClipping(Vector start, Vector end)
Clipping the lines according to viewing volumn.

Parameters:
  `start` -
  `end` -
Returns:

### processEvent

public PrimitiveRenderEvent processEvent(PrimitiveRenderEvent event, double xOffset, double yOffset)

Parameters:
  `renderingEvents` -
Returns:

### processEvent_noclip

public PrimitiveRenderEvent processEvent_noclip(PrimitiveRenderEvent event, double xOffset, double yOffset)

Parameters:
  `renderingEvents` -
Returns:

### processEvent

public List processEvent(List renderingEvents, double xOffset, double yOffset)
Transforms 3D polygons and sort their rendering order, and antialias.

Parameters:
  `renderingEvents` -
  `xOffset` -
  `yOffset` -
Returns:

### processEvent

public List processEvent(List renderingEvents, double xOffset, double yOffset, boolean antialiasing)
Transforms 3D polygons and sort their rendering order, and antialias.

Parameters:
  `renderingEvents` -
  `xOffset` -
  `yOffset` -
  `antialiasing` -
Returns:

### getSharedEdge

public WrappedInstruction getSharedEdge(I3DRenderEvent event1, I3DRenderEvent event2, double xOffset, double yOffset)

### getViewReferencePoint

public Vector getViewReferencePoint()

### getObjectFromEvent

public static Object3D getObjectFromEvent(Object event)

### getParentObject

public static Object3D getParentObject(Object event)

Parameters:
  `event` -
Returns:

### getObjectFromEvent

public static Object3D getObjectFromEvent(Object event, boolean bParent)